#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20120115

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)


#ifndef yyparse
#define yyparse    libaacs_yyparse
#endif /* yyparse */

#ifndef yylex
#define yylex      libaacs_yylex
#endif /* yylex */

#ifndef yyerror
#define yyerror    libaacs_yyerror
#endif /* yyerror */

#ifndef yychar
#define yychar     libaacs_yychar
#endif /* yychar */

#ifndef yyval
#define yyval      libaacs_yyval
#endif /* yyval */

#ifndef yylval
#define yylval     libaacs_yylval
#endif /* yylval */

#ifndef yydebug
#define yydebug    libaacs_yydebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    libaacs_yynerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  libaacs_yyerrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      libaacs_yylhs
#endif /* yylhs */

#ifndef yylen
#define yylen      libaacs_yylen
#endif /* yylen */

#ifndef yydefred
#define yydefred   libaacs_yydefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    libaacs_yydgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   libaacs_yysindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   libaacs_yyrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   libaacs_yygindex
#endif /* yygindex */

#ifndef yytable
#define yytable    libaacs_yytable
#endif /* yytable */

#ifndef yycheck
#define yycheck    libaacs_yycheck
#endif /* yycheck */

#ifndef yyname
#define yyname     libaacs_yyname
#endif /* yyname */

#ifndef yyrule
#define yyrule     libaacs_yyrule
#endif /* yyrule */
#define YYPREFIX "libaacs_yy"

#define YYPURE 1

#line 2 "keydbcfg-parser.y"
/*
 * This file is part of libaacs
 * Copyright (C) 2010  gates
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "file/keydbcfg.h"
#include "util/macro.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Disable some warnings triggered by generated parser */
#if defined __GNUC__
#pragma GCC diagnostic ignored "-Wredundant-decls"
#pragma GCC diagnostic ignored "-Wimplicit-function-declaration"
#pragma GCC diagnostic ignored "-Wunused-parameter"
#pragma GCC visibility push(hidden)
#endif

/* Fix some warnings trigger by -Wundef which can't be ignored */
#define YYENABLE_NLS 0
#define YYLTYPE_IS_TRIVIAL 0

#define DIGIT_KEY_PAIR_LIST_FREE(X) do   \
{                                        \
  while (X)                              \
  {                                      \
    digit_key_pair_list *next = X->next; \
    X_FREE(X->key_pair.key);             \
    X_FREE(X);                           \
    X = next;                            \
  }                                      \
} while (0);

/* enum used in certain functions to add proper title entry */
enum
{
  ENTRY_TYPE_DISCID,
  ENTRY_TYPE_TITLE,
  ENTRY_TYPE_DATE,
  ENTRY_TYPE_MEK,
  ENTRY_TYPE_VID,
  ENTRY_TYPE_BN,
  ENTRY_TYPE_VUK,
  ENTRY_TYPE_PAK,
  ENTRY_TYPE_TK,
  ENTRY_TYPE_UK
};

static dk_list *new_dk_list();
static dk_list *add_dk_list_entry(dk_list *list, char *key, char *node);
static pk_list *new_pk_list();
static pk_list *add_pk_list_entry(pk_list *list, char *key);
static cert_list *new_cert_list();
static cert_list *add_cert_list(cert_list *list, char *host_priv_key,
                         char *host_cert, char *host_nonce,
                         char *host_key_point);
static title_entry_list *new_title_entry_list();
static int add_entry(title_entry_list *list, int type, char *entry);
static digit_key_pair_list *new_digit_key_pair_list();
static digit_key_pair_list *add_digit_key_pair_entry(digit_key_pair_list *list,
                              int type, unsigned int digit, char *key);
static int add_date_entry(title_entry_list *list, unsigned int year,
                          unsigned int month, unsigned int day);
void yyerror (void *scanner, dk_list *dklist, pk_list *pklist, cert_list *clist,
              title_entry_list *celist, digit_key_pair_list *dkplist,
              const char *msg);
extern int libaacs_yyget_lineno  (void *scanner);

/* uncomment the line below for debugging */
/* int yydebug = 1;*/
#line 105 "keydbcfg-parser.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union
{
  char *string;
  unsigned int digit;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 199 "keydbcfg-parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void * scanner, dk_list * dklist, pk_list * pklist, cert_list * clist, title_entry_list * celist, digit_key_pair_list * dkplist)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# ifdef YYLEX_PARAM_TYPE
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, YYLEX_PARAM_TYPE YYLEX_PARAM)
# else
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, void * YYLEX_PARAM)
# endif
# define YYLEX yylex(&yylval, YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(YYSTYPE *yylval, void * scanner)
# define YYLEX yylex(&yylval, scanner)
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(void * scanner, dk_list * dklist, pk_list * pklist, cert_list * clist, title_entry_list * celist, digit_key_pair_list * dkplist, const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(scanner, dklist, pklist, clist, celist, dkplist, msg)
#endif

extern int YYPARSE_DECL();

#define HEXSTRING 257
#define DISC_TITLE 258
#define DIGIT 259
#define KEYWORD_DEVICE_KEY 260
#define KEYWORD_DEVICE_NODE 261
#define KEYWORD_HOST_PRIV_KEY 262
#define KEYWORD_HOST_CERT 263
#define KEYWORD_HOST_NONCE 264
#define KEYWORD_HOST_KEY_POINT 265
#define PUNCT_EQUALS_SIGN 266
#define PUNCT_VERTICAL_BAR 267
#define PUNCT_HYPHEN 268
#define ENTRY_ID_DK 269
#define ENTRY_ID_PK 270
#define ENTRY_ID_HC 271
#define ENTRY_ID_DATE 272
#define ENTRY_ID_MEK 273
#define ENTRY_ID_VID 274
#define ENTRY_ID_BN 275
#define ENTRY_ID_VUK 276
#define ENTRY_ID_PAK 277
#define ENTRY_ID_TK 278
#define ENTRY_ID_UK 279
#define NEWLINE 280
#define BAD_ENTRY 281
#define YYERRCODE 256
static const short libaacs_yylhs[] = {                   -1,
    0,    0,    0,    0,   10,   10,   12,   12,   12,   12,
   12,   13,   13,    8,    9,   14,   14,   15,   15,    3,
    4,    5,    6,   16,   16,   11,   11,   17,    1,    2,
   18,   18,   19,   19,   19,   19,   19,   19,   19,   19,
   20,   21,   22,   23,   28,   28,   29,   24,   25,   30,
   30,   31,   26,   32,   32,   33,   27,   34,   34,   35,
    7,    7,
};
static const short libaacs_yylen[] = {                    2,
    2,    1,    1,    0,    2,    1,    1,    1,    1,    1,
    2,    6,    5,    2,    2,    4,    3,   10,    9,    2,
    2,    2,    2,    4,    3,    2,    1,    3,    1,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    6,    2,    2,    2,    3,    1,    3,    2,    2,    3,
    1,    3,    2,    3,    1,    3,    2,    3,    1,    3,
    2,    1,
};
static const short libaacs_yydefred[] = {                 0,
    0,   62,    0,    0,    0,   27,    0,    0,    0,    0,
    0,    6,    7,    8,    9,   10,    0,   11,    0,    0,
    0,    0,    0,    0,   61,    0,    5,    0,    0,    0,
   26,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,    0,   17,    0,    0,   30,   28,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   46,    0,    0,    0,
   51,    0,    0,   55,    0,    0,   59,   25,   31,    0,
    0,    0,    0,    0,   16,    0,   24,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   13,    0,    0,
    0,    0,    0,    0,   45,    0,   50,    0,   54,    0,
   58,    0,    0,   12,    0,    0,    0,    0,    0,   41,
    0,    0,    0,    0,   19,    0,   18,
};
static const short libaacs_yydgoto[] = {                  7,
    8,   57,   23,   83,  113,  122,    9,   20,   81,   10,
   11,   12,   13,   14,   15,   16,   17,   41,   42,   43,
   44,   45,   46,   47,   48,   49,   50,   66,   67,   70,
   71,   73,   74,   76,   77,
};
static const short libaacs_yysindex[] = {              -248,
 -277,    0, -255, -253, -252,    0,    0, -259, -246, -248,
 -243,    0,    0,    0,    0,    0, -163,    0, -253, -254,
 -256, -253, -247, -239,    0, -243,    0, -255, -253, -252,
    0, -163, -224, -253, -253, -221, -253, -210, -209, -208,
 -154,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -246, -249,    0, -246, -211,    0,    0, -204, -251, -203,
 -145, -202, -246, -246, -191, -188,    0, -246, -187, -185,
    0, -184, -181,    0, -178, -175,    0,    0,    0, -253,
 -215, -253, -165, -249,    0, -211,    0, -176, -253, -221,
 -253, -210, -253, -209, -253, -208, -246,    0, -246, -161,
 -200, -162, -164, -246,    0, -246,    0, -246,    0, -246,
    0, -253, -160,    0, -161, -153, -246,  -66,  -67,    0,
 -253,  -79,  -66, -246,    0,  -78,    0,
};
static const short libaacs_yyrindex[] = {               203,
    0,    0,    0,    0,    0,    0,    0,    0,  -62,  205,
  206,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  207,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -59,    0,    0,  -58,    0,    0,    0,    0,    0,    0,
    0,    0, -136, -127,    0, -118,    0, -109,    0, -100,
    0,    0,  -91,    0,    0,  -82,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -70,    0,  -56,    0,
    0,    0,    0, -233,    0, -219,    0, -205,    0, -179,
    0,    0,    0,    0,    0,    0,  -55,    0,    0,    0,
    0,    0,    0,  -65,    0,    0,    0,
};
static const short libaacs_yygindex[] = {                 0,
    0,    0,  183,  128,  101,   94,   -4,  190,  135,    0,
  210,  211,    0,    0,    0,    0,   -9,  191,  -25,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  132,    0,
  133,    0,  130,    0,  131,
};
#define YYTABLESIZE 227
static const short libaacs_yytable[] = {                 21,
   25,   32,   18,    2,   19,   25,   24,    1,    2,   22,
   25,   80,   52,    2,   51,   79,   32,   54,   56,   55,
    3,    4,    5,   53,   59,   28,   29,   30,   85,   63,
   64,    6,   68,   47,   62,   79,   31,   65,   47,   47,
   47,   47,   47,   47,   47,   47,   47,   52,   69,   72,
   75,   82,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   56,   84,   86,   98,   88,   56,   56,   56,   56,
   56,   56,   56,   56,   56,   97,   89,   99,   90,  114,
   91,   92,  103,   93,  104,   94,  106,   60,  108,   95,
  110,   96,   60,   60,   60,   60,   60,   60,   60,   60,
   60,  100,  112,  116,  115,  120,  118,  117,   33,   34,
   35,   36,   37,   38,   39,   40,  124,   33,   34,   35,
   36,   37,   38,   39,   40,   78,   33,   34,   35,   36,
   37,   38,   39,   40,   87,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   48,   48,   48,   48,   48,   48,   48,   48,
   48,   49,   49,   49,   49,   49,   49,   49,   49,   49,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   57,
   57,   57,   57,   57,   57,   57,   57,   57,  121,  123,
  125,  127,    4,   29,    2,    3,    1,   14,   20,   15,
   21,   22,   60,  102,   23,  119,  126,   58,  101,   26,
   27,  105,   61,  109,  107,    0,  111,
};
static const short libaacs_yycheck[] = {                  4,
  257,   11,  280,  257,  260,  257,  266,  256,  257,  262,
  257,  261,  267,  257,   19,   41,   26,   22,  258,  267,
  269,  270,  271,  280,   29,  269,  270,  271,  280,   34,
   35,  280,   37,  267,  259,   61,  280,  259,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  267,  259,  259,
  259,  263,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  267,  267,  267,  280,  268,  272,  273,  274,  275,
  276,  277,  278,  279,  280,   80,  268,   82,  267,  280,
  268,  267,  259,  268,   89,  267,   91,  267,   93,  268,
   95,  267,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  267,  264,  268,  267,  259,  267,  112,  272,  273,
  274,  275,  276,  277,  278,  279,  121,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  265,  267,
  280,  280,    0,  266,    0,    0,    0,  267,  267,  280,
  267,  267,   30,   86,  280,  115,  123,   28,   84,   10,
   10,   90,   32,   94,   92,   -1,   96,
};
#define YYFINAL 7
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 281
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"HEXSTRING","DISC_TITLE","DIGIT",
"KEYWORD_DEVICE_KEY","KEYWORD_DEVICE_NODE","KEYWORD_HOST_PRIV_KEY",
"KEYWORD_HOST_CERT","KEYWORD_HOST_NONCE","KEYWORD_HOST_KEY_POINT",
"PUNCT_EQUALS_SIGN","PUNCT_VERTICAL_BAR","PUNCT_HYPHEN","ENTRY_ID_DK",
"ENTRY_ID_PK","ENTRY_ID_HC","ENTRY_ID_DATE","ENTRY_ID_MEK","ENTRY_ID_VID",
"ENTRY_ID_BN","ENTRY_ID_VUK","ENTRY_ID_PAK","ENTRY_ID_TK","ENTRY_ID_UK",
"NEWLINE","BAD_ENTRY",
};
static const char *yyrule[] = {
"$accept : config_file",
"config_file : config_entry_list newline_list",
"config_file : config_entry_list",
"config_file : newline_list",
"config_file :",
"config_entry_list : config_entry_list config_entry",
"config_entry_list : config_entry",
"config_entry : dk_entry",
"config_entry : pk_entry",
"config_entry : host_cert_entry",
"config_entry : title_entry",
"config_entry : error NEWLINE",
"dk_entry : newline_list ENTRY_ID_DK device_key PUNCT_VERTICAL_BAR device_node NEWLINE",
"dk_entry : ENTRY_ID_DK device_key PUNCT_VERTICAL_BAR device_node NEWLINE",
"device_key : KEYWORD_DEVICE_KEY hexstring_list",
"device_node : KEYWORD_DEVICE_NODE hexstring_list",
"pk_entry : newline_list ENTRY_ID_PK hexstring_list NEWLINE",
"pk_entry : ENTRY_ID_PK hexstring_list NEWLINE",
"host_cert_entry : newline_list ENTRY_ID_HC host_priv_key PUNCT_VERTICAL_BAR host_cert PUNCT_VERTICAL_BAR host_nonce PUNCT_VERTICAL_BAR host_key_point NEWLINE",
"host_cert_entry : ENTRY_ID_HC host_priv_key PUNCT_VERTICAL_BAR host_cert PUNCT_VERTICAL_BAR host_nonce PUNCT_VERTICAL_BAR host_key_point NEWLINE",
"host_priv_key : KEYWORD_HOST_PRIV_KEY hexstring_list",
"host_cert : KEYWORD_HOST_CERT hexstring_list",
"host_nonce : KEYWORD_HOST_NONCE hexstring_list",
"host_key_point : KEYWORD_HOST_KEY_POINT hexstring_list",
"title_entry : newline_list disc_info entry_list NEWLINE",
"title_entry : disc_info entry_list NEWLINE",
"newline_list : newline_list NEWLINE",
"newline_list : NEWLINE",
"disc_info : discid PUNCT_EQUALS_SIGN disc_title",
"discid : hexstring_list",
"disc_title : DISC_TITLE",
"entry_list : entry_list entry",
"entry_list : entry",
"entry : date_entry",
"entry : mek_entry",
"entry : vid_entry",
"entry : bn_entry",
"entry : vuk_entry",
"entry : pak_entry",
"entry : tk_entry",
"entry : uk_entry",
"date_entry : ENTRY_ID_DATE DIGIT PUNCT_HYPHEN DIGIT PUNCT_HYPHEN DIGIT",
"mek_entry : ENTRY_ID_MEK hexstring_list",
"vid_entry : ENTRY_ID_VID hexstring_list",
"bn_entry : ENTRY_ID_BN bn_data_list",
"bn_data_list : bn_data_list PUNCT_VERTICAL_BAR bn_data",
"bn_data_list : bn_data",
"bn_data : DIGIT PUNCT_HYPHEN hexstring_list",
"vuk_entry : ENTRY_ID_VUK hexstring_list",
"pak_entry : ENTRY_ID_PAK pak_data_list",
"pak_data_list : pak_data_list PUNCT_VERTICAL_BAR pak_data",
"pak_data_list : pak_data",
"pak_data : DIGIT PUNCT_HYPHEN hexstring_list",
"tk_entry : ENTRY_ID_TK tk_data_list",
"tk_data_list : tk_data_list PUNCT_VERTICAL_BAR tk_data",
"tk_data_list : tk_data",
"tk_data : DIGIT PUNCT_HYPHEN hexstring_list",
"uk_entry : ENTRY_ID_UK uk_data_list",
"uk_data_list : uk_data_list PUNCT_VERTICAL_BAR uk_data",
"uk_data_list : uk_data",
"uk_data : DIGIT PUNCT_HYPHEN hexstring_list",
"hexstring_list : hexstring_list HEXSTRING",
"hexstring_list : HEXSTRING",

};
#endif

int      yydebug;
int      yynerrs;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
#line 424 "keydbcfg-parser.y"
/* Function to parse a config file */
int keydbcfg_parse_config(config_file *cfgfile, const char *path)
{
  if (!cfgfile || !path)
    return 0;

  FILE * fp = fopen(path, "r");
  if (!fp)
    return 0;

  dk_list *head_dklist = new_dk_list();
  pk_list *head_pklist = new_pk_list();
  cert_list *head_clist = new_cert_list();
  title_entry_list *head_celist = new_title_entry_list();
  digit_key_pair_list *dkplist = NULL;

  void *scanner;
  libaacs_yylex_init(&scanner);
  libaacs_yyset_in(fp, scanner);
  int retval = yyparse(scanner, head_dklist, head_pklist, head_clist,
                       head_celist, dkplist);
  libaacs_yylex_destroy(scanner);

  cfgfile->dkl = head_dklist;
  cfgfile->pkl = head_pklist;
  cfgfile->host_cert_list = head_clist;
  cfgfile->list = head_celist;

  if (retval)
    return 0;

  return 1;
}

/* Function that returns pointer to new config file object */
config_file *keydbcfg_new_config_file()
{
  config_file *cfgfile = (config_file *)malloc(sizeof(*cfgfile));
  memset(cfgfile, 0, sizeof(*cfgfile));
  return cfgfile;
}

/* Function that closes and frees a config file object */
int keydbcfg_config_file_close(config_file *cfgfile)
{
  /* free pk list */
  while (cfgfile->pkl)
  {
    pk_list *next = cfgfile->pkl->next;
    X_FREE(cfgfile->pkl->key);
    X_FREE(cfgfile->pkl);
    cfgfile->pkl = next;
  }

  /* free dk list */
  while (cfgfile->dkl)
  {
    dk_list *next = cfgfile->dkl->next;
    X_FREE(cfgfile->dkl->key);
    X_FREE(cfgfile->dkl);
    cfgfile->dkl = next;
  }

  /* free host cert list */
  while (cfgfile->host_cert_list)
  {
    cert_list *next = cfgfile->host_cert_list->next;
    X_FREE(cfgfile->host_cert_list->host_priv_key);
    X_FREE(cfgfile->host_cert_list->host_cert);
    X_FREE(cfgfile->host_cert_list->host_nonce);
    X_FREE(cfgfile->host_cert_list->host_key_point);
    X_FREE(cfgfile->host_cert_list);
    cfgfile->host_cert_list = next;
  }

  /* free title entries */
  while (cfgfile->list)
  {
    title_entry_list *next = cfgfile->list->next;
    X_FREE(cfgfile->list->entry.discid);
    X_FREE(cfgfile->list->entry.title);
    X_FREE(cfgfile->list->entry.mek);
    X_FREE(cfgfile->list->entry.vid);
    DIGIT_KEY_PAIR_LIST_FREE(cfgfile->list->entry.bn);
    X_FREE(cfgfile->list->entry.vuk);
    DIGIT_KEY_PAIR_LIST_FREE(cfgfile->list->entry.pak);
    DIGIT_KEY_PAIR_LIST_FREE(cfgfile->list->entry.tk);
    DIGIT_KEY_PAIR_LIST_FREE(cfgfile->list->entry.uk);
    X_FREE(cfgfile->list);
    cfgfile->list = next;
  }

  /* free the config file object */
  X_FREE(cfgfile);

  return 1;
}

/* Function to return new dk_list object */
static dk_list *new_dk_list()
{
  dk_list *dkl = (dk_list *)malloc(sizeof(*dkl));
  memset(dkl, 0, sizeof(*dkl));
  return dkl;
}

/* Function to add dk to config file */
static dk_list *add_dk_list_entry(dk_list *list, char *key, char *node)
{
  if (!list)
  {
    printf("Error: No dk list passed as parameter.\n");
    return NULL;
  }

  list->key  = key;
  list->node = strtoul(node, NULL, 16);
  list->next = new_dk_list();

  X_FREE(node);

  return list->next;
}

/* Function to return new pk_list object */
static pk_list *new_pk_list()
{
  pk_list *pkl = (pk_list *)malloc(sizeof(*pkl));
  memset(pkl, 0, sizeof(*pkl));
  return pkl;
}

/* Function to add pk to config file */
static pk_list *add_pk_list_entry(pk_list *list, char *key)
{
  if (!list)
  {
    printf("Error: No pk list passed as parameter.\n");
    return NULL;
  }

  list->key  = key;
  list->next = new_pk_list();

  return list->next;
}

/* Function to create new certificate list */
static cert_list *new_cert_list()
{
  cert_list *list = (cert_list *)malloc(sizeof(*list));
  if (!list)
  {
    printf("Error allocating memory for new certificate list!\n");
    return NULL;
  }

  memset(list, 0, sizeof(*list));

  return list;
}

/* Function to add certificate list entry into config file object */
static cert_list *add_cert_list(cert_list *list, char *host_priv_key,
                         char *host_cert, char *host_nonce,
                         char *host_key_point)
{
  if (!list)
  {
    printf("Error: no certificate list object passed as parameter.\n");
    return NULL;
  }

  list->host_priv_key = host_priv_key;
  list->host_cert = host_cert;
  list->host_nonce = host_nonce;
  list->host_key_point = host_key_point;

  list->next = new_cert_list();

  return list->next;
}

/* Function that returns pointer to new title entry list */
title_entry_list *new_title_entry_list()
{
  title_entry_list *list = (title_entry_list *)malloc(sizeof(*list));
  if (!list)
  {
    printf("Error allocating memory for new title entry list!\n");
    return NULL;
  }

  memset(list, 0, sizeof(*list));

  return list;
}

/* Function to add standard string entries to a config entry */
static int add_entry(title_entry_list *list, int type, char *entry)
{
  if (!list)
  {
    printf("Error: No title list passed as parameter.\n");
    return 0;
  }

  switch (type)
  {
    case ENTRY_TYPE_DISCID:
      X_FREE(list->entry.discid);
      list->entry.discid = entry;
      break;

    case ENTRY_TYPE_TITLE:
      X_FREE(list->entry.title);
      list->entry.title = (char*)malloc(strlen(entry) + 1);
      strcpy(list->entry.title, entry);
      break;

    case ENTRY_TYPE_MEK:
      X_FREE(list->entry.mek);
      list->entry.mek = entry;
      break;

    case ENTRY_TYPE_VID:
      X_FREE(list->entry.vid);
      list->entry.vid = entry;
      break;

    case ENTRY_TYPE_VUK:
      X_FREE(list->entry.vuk);
      list->entry.vuk = entry;
      break;

    default:
      X_FREE(entry);
      printf("WARNING: entry type passed in unknown\n");
      return 0;
  }

  return 1;
}

/* Function that returns pointer to new digit key pair list */
static digit_key_pair_list *new_digit_key_pair_list()
{
  digit_key_pair_list *list = (digit_key_pair_list *)malloc(sizeof(*list));
  if (!list)
  {
    printf("Error allocating memory for new digit key pair entry list!\n");
    return NULL;
  }

  memset(list, 0, sizeof(*list));

  return list;
}

/* Function used to add a digit/key pair to a list of digit key pair entries */
static digit_key_pair_list *add_digit_key_pair_entry(digit_key_pair_list *list,
                              int type, unsigned int digit, char *key)
{
  if (!list)
  {
    printf("Error: No digit key pair list passed as parameter.\n");
    return NULL;
  }

  list->key_pair.digit = digit;
  list->key_pair.key = key;

  list->next = new_digit_key_pair_list();

  return list->next;
}

/* Function to add a date entry */
static int add_date_entry(title_entry_list *list, unsigned int year,
                          unsigned int month, unsigned int day)
{
  if (!list)
  {
    printf("Error: No title list passed as parameter.\n");
    return 0;
  }

  list->entry.date.year = year;
  list->entry.date.month = month;
  list->entry.date.day = day;

  return 1;
}

/* Our definition of yyerror */
void yyerror (void *scanner, dk_list *dklist, pk_list *pklist, cert_list *clist,
              title_entry_list *celist, digit_key_pair_list *dkplist,
              const char *msg)
{
  fprintf(stderr, "%s: line %d\n", msg, libaacs_yyget_lineno(scanner));
}
#line 806 "keydbcfg-parser.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int      yyerrflag;
    int      yychar;
    YYSTYPE  yyval;
    YYSTYPE  yylval;

    /* variables for the parser stack */
    YYSTACKDATA yystack;
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror(scanner, dklist, pklist, clist, celist, dkplist, "syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 11:
#line 163 "keydbcfg-parser.y"
	{
      fprintf(stderr, "bad entry at or around line %d\n",
              libaacs_yyget_lineno(scanner) - 1);
      yyerrok;
    }
break;
case 12:
#line 172 "keydbcfg-parser.y"
	{
      dklist = add_dk_list_entry(dklist, yystack.l_mark[-3].string, yystack.l_mark[-1].string);
    }
break;
case 13:
#line 176 "keydbcfg-parser.y"
	{
      dklist = add_dk_list_entry(dklist, yystack.l_mark[-3].string, yystack.l_mark[-1].string);
    }
break;
case 14:
#line 183 "keydbcfg-parser.y"
	{ yyval.string = yystack.l_mark[0].string; }
break;
case 15:
#line 188 "keydbcfg-parser.y"
	{ yyval.string = yystack.l_mark[0].string; }
break;
case 16:
#line 193 "keydbcfg-parser.y"
	{
      pklist = add_pk_list_entry(pklist, yystack.l_mark[-1].string);
    }
break;
case 17:
#line 197 "keydbcfg-parser.y"
	{
      pklist = add_pk_list_entry(pklist, yystack.l_mark[-1].string);
    }
break;
case 18:
#line 204 "keydbcfg-parser.y"
	{
      clist = add_cert_list(clist, yystack.l_mark[-7].string, yystack.l_mark[-5].string, yystack.l_mark[-3].string, yystack.l_mark[-1].string);
    }
break;
case 19:
#line 208 "keydbcfg-parser.y"
	{
      clist = add_cert_list(clist, yystack.l_mark[-7].string, yystack.l_mark[-5].string, yystack.l_mark[-3].string, yystack.l_mark[-1].string);
    }
break;
case 20:
#line 215 "keydbcfg-parser.y"
	{ yyval.string = yystack.l_mark[0].string; }
break;
case 21:
#line 220 "keydbcfg-parser.y"
	{ yyval.string = yystack.l_mark[0].string; }
break;
case 22:
#line 225 "keydbcfg-parser.y"
	{ yyval.string = yystack.l_mark[0].string; }
break;
case 23:
#line 230 "keydbcfg-parser.y"
	{ yyval.string = yystack.l_mark[0].string; }
break;
case 24:
#line 235 "keydbcfg-parser.y"
	{
      celist->next = new_title_entry_list();
      celist = celist->next;
    }
break;
case 25:
#line 240 "keydbcfg-parser.y"
	{
      celist->next = new_title_entry_list();
      celist = celist->next;
    }
break;
case 28:
#line 253 "keydbcfg-parser.y"
	{
      add_entry(celist, ENTRY_TYPE_DISCID, yystack.l_mark[-2].string);
      add_entry(celist, ENTRY_TYPE_TITLE, yystack.l_mark[0].string);
    }
break;
case 41:
#line 285 "keydbcfg-parser.y"
	{
      add_date_entry(celist, yystack.l_mark[-4].digit, yystack.l_mark[-2].digit, yystack.l_mark[0].digit);
    }
break;
case 42:
#line 292 "keydbcfg-parser.y"
	{
      add_entry(celist, ENTRY_TYPE_MEK, yystack.l_mark[0].string);
    }
break;
case 43:
#line 299 "keydbcfg-parser.y"
	{
      add_entry(celist, ENTRY_TYPE_VID, yystack.l_mark[0].string);
    }
break;
case 44:
#line 306 "keydbcfg-parser.y"
	{
      dkplist = NULL;
    }
break;
case 47:
#line 318 "keydbcfg-parser.y"
	{
      if (!dkplist)
      {
        dkplist = new_digit_key_pair_list();
        celist->entry.bn = dkplist;
      }
      dkplist = add_digit_key_pair_entry(dkplist, ENTRY_TYPE_BN, yystack.l_mark[-2].digit, yystack.l_mark[0].string);
    }
break;
case 48:
#line 330 "keydbcfg-parser.y"
	{
      add_entry(celist, ENTRY_TYPE_VUK, yystack.l_mark[0].string);
    }
break;
case 49:
#line 337 "keydbcfg-parser.y"
	{
      dkplist = NULL;
    }
break;
case 52:
#line 349 "keydbcfg-parser.y"
	{
      if (!dkplist)
      {
        dkplist = new_digit_key_pair_list();
        celist->entry.pak = dkplist;
      }
      dkplist = add_digit_key_pair_entry(dkplist, ENTRY_TYPE_PAK, yystack.l_mark[-2].digit, yystack.l_mark[0].string);
    }
break;
case 53:
#line 361 "keydbcfg-parser.y"
	{
      dkplist = NULL;
    }
break;
case 56:
#line 373 "keydbcfg-parser.y"
	{
      if (!dkplist)
      {
        dkplist = new_digit_key_pair_list();
        celist->entry.tk = dkplist;
      }
      dkplist = add_digit_key_pair_entry(dkplist, ENTRY_TYPE_TK, yystack.l_mark[-2].digit, yystack.l_mark[0].string);
    }
break;
case 57:
#line 385 "keydbcfg-parser.y"
	{
      dkplist = NULL;
    }
break;
case 60:
#line 397 "keydbcfg-parser.y"
	{
      if (!dkplist)
      {
        dkplist = new_digit_key_pair_list();
        celist->entry.uk = dkplist;
      }
      dkplist = add_digit_key_pair_entry(dkplist, ENTRY_TYPE_UK, yystack.l_mark[-2].digit, yystack.l_mark[0].string);
    }
break;
case 61:
#line 409 "keydbcfg-parser.y"
	{
      char *str = (char*)malloc(strlen(yystack.l_mark[-1].string) + strlen(yystack.l_mark[0].string) + 1);
      strcpy(str, yystack.l_mark[-1].string);
      strcat(str, yystack.l_mark[0].string);
      yyval.string = str;
      X_FREE(yystack.l_mark[-1].string);
    }
break;
case 62:
#line 417 "keydbcfg-parser.y"
	{
      char *str = (char*)malloc(strlen(yystack.l_mark[0].string) + 1);
      strcpy(str, yystack.l_mark[0].string);
      yyval.string = str;
    }
break;
#line 1218 "keydbcfg-parser.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror(scanner, dklist, pklist, clist, celist, dkplist, "yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
